//  Copyright (C) University of Vienna, 2013-2015
//  All rights reserved.
//
//  Author: Ali Baharev
//
//  Please refer to the LICENSE.txt file in the top directory
//
package sdms;

import java.util.Collection;
import java.util.SortedSet;
import java.util.TreeMap;

public interface Solution {
    
    boolean isSuccessful();
    
    double getInfeasibilityBestObjective();
    
    double getNormOfInfeasibility();
    
    TreeMap<String,Double> getValues(SortedSet<String> subsetOfVars);
    
    double[] values(Collection<String> vars);
    
    TreeMap<String,Double> dbgGetValues(String... names);
    
    TreeMap<String,Double> getValues(SortedSet<String> subsetOfVars, TreeMap<String,Double> artificallyFixed);
    
    TreeMap<String,Double> getAllVars();
    
    Collection<Double> getValues();
    
    SortedSet<String> getVarNames();
    
    int dimension();
    
    Solution extend(SortedSet<String> variablesToBeRemoved,
                    TreeMap<String,Double> subproblemSolutionForGuessedVars, 
                    double infeasBestObjective                               );

    Solution extend(TreeMap<String, Double> subproblemSolutionForGuessedVars,
                    double infeasBestObjective);
    
    void setScaledBoundconstraintViolation(double violSquared);
    
    void setInfNormScaledBoundViol(double infNorm);
    
    double getInfNormScaledBoundViol();
    
    double getScaledBoundconstraintViolationSquared();
    
    void incrementCumulativeInfeasibilityWithBestObjAndBoundViolSquared();
    
    double getCumulativeInfeasibility();

    void setCumulativeInfeasibilitySquared(double viol2);
    
    void setAllViolations(Violations viol);

    double getInfeasibilityInfinityNorm();

    void markAsFromForwardProjection();

    boolean isFromForwardProjection();
}
