//  Copyright (C) University of Vienna, 2013-2015
//  All rights reserved.
//
//  Author: Ali Baharev
//
//  Please refer to the LICENSE.txt file in the top directory
//
package sdms;

public interface Solver {

    /** Starting point in alphabetical order, the Solver knows how to repermute it into internal representation */
    Solution solveSubNLPProblem(SubNLPProblem subProblem, double[] startingPoint);
    
    /** Same as above but the solution values of the guessed vars are also stored in the last argument (out parameter) */ 
    Solution solveSubNLPProblem(SubNLPProblem subProblem, double[] startingPoint, double[] solutionOutParam);

    void dumpStatistics(String file);
}
