//  Copyright (C) University of Vienna, 2013-2015
//  All rights reserved.
//
//  Author: Ali Baharev
//
//  Please refer to the LICENSE.txt file in the top directory
//
package sdms;

import java.util.TreeMap;
import java.util.TreeSet;

public interface SubproblemSelector {
    
    boolean setNext();
    
    void setFullProblem();
    
    TreeSet<String> getFirstVariables();
    
    TreeSet<String> getNextConstraints();
    
    TreeSet<String> getFixedVars();
    
    TreeSet<String> getVariablesToGuess();
    
    TreeMap<String, String[]> dbgFullProbSparsity();   
    
    TreeSet<String> getProcessedConstraintsSoFar();
    
    TreeSet<String> allConsBetweenCurrentAndPast(int maxStepLength);
    
    boolean hasPrecedingSubproblem(int maxStepLength);
    
    TreeSet<String> xVarsBetweenCurrentAndPast(int maxStepLength);
    
    TreeSet<String> yVarsBetweenCurrentAndPast(int maxStepLength);
    
    boolean isLastSubproblem(); 
}
