//  Copyright (C) University of Vienna, 2013-2015
//  All rights reserved.
//
//  Author: Ali Baharev
//
//  Please refer to the LICENSE.txt file in the top directory
//
package sdms;

public final class Violations {
    
    public final double L2SquaredConsAndBound;
    public final double LinfConsAndBound; 
    public final double LinfBoundOnly;

    public Violations(double L2normSquared, double infinityNorm, double boundsOnlyInf) {
        this.L2SquaredConsAndBound = L2normSquared;
        this.LinfConsAndBound     = infinityNorm;
        this.LinfBoundOnly        = boundsOnlyInf;
    }
    
    public boolean hasNans() {
        return Double.isNaN(L2SquaredConsAndBound) || Double.isNaN(LinfConsAndBound) || Double.isNaN(LinfBoundOnly);
    }
}
