package sdms.impl;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map.Entry;
import java.util.Random;
import java.util.Scanner;
import java.util.TreeMap;

import sdms.Solution;

public class VA27_hack {

    // It is just a horrible hack to run VA27 on the stewgou40 benchmark
    
    public static ArrayList<Solution> run(ArrayList<Solution> allPartialSolutions) {
        
        String[] nameArray = {"n1", "n2", "n3", "h11", "h12", "h13", "h21", "h22", "h23"};
        List<String> names = Arrays.asList(nameArray);
        
        StringBuilder builder = new StringBuilder();
        for (Solution sol : allPartialSolutions) {
            double[] values = sol.values(names);
            for (double d : values) {
                builder.append(String.format("%.15f", d));
                builder.append('\n');
            }
            builder.append('\n');
        }
        String sols = builder.toString();
        
        try (BufferedWriter bw = new BufferedWriter(new FileWriter("/tmp/input.txt"))) {
            bw.write(String.format("%d", allPartialSolutions.size()));
            bw.newLine();
            bw.write(sols);
        }
        catch(IOException exp) { }
                
        try {
            Process p = Runtime.getRuntime().exec("/tmp/stewgou40");
            int retval = p.waitFor();
            assert retval == 0;
        } catch (IOException | InterruptedException e) {
            e.printStackTrace();            
        }
        
        ArrayList<Solution> result = new ArrayList<Solution>();
             
        try (Scanner sc = new Scanner(new File("/tmp/output.txt"))) {
            int n_sols = sc.nextInt();
            int n = nameArray.length;
            for (int i=0; i<n_sols; ++i) {
                TreeMap<String,Double> values = new TreeMap<>();
                for (int j=0; j<n; ++j)
                    values.put(nameArray[j], sc.nextDouble());
                sc.nextLine();
                result.add(new SolutionImpl(values, 0.0));
            }
        }
        catch (FileNotFoundException exp) { }
        
        return result;
    }
    
    public static ArrayList<Solution> perturb(ArrayList<TreeMap<String,Double>> refSols) {
        // Applying small perturbations to stewgou40; run it with 40 points
        Random rnd = new Random(31L);
        
        ArrayList<Solution> result = new ArrayList<Solution>();
        
        for (TreeMap<String,Double> s : refSols) {
           TreeMap<String,Double> sol = new TreeMap<String,Double>();
            for (Entry<String, Double> e : s.entrySet()) {
                double d = e.getValue() + ((rnd.nextDouble()-0.5)/0.5)*0.01;
                d = Math.max(-1, d);
                d = Math.min( 1, d);
                //System.out.println(d);
                sol.put(e.getKey(), d);
            }
            result.add(new SolutionImpl(sol, 0.0));
        }
        return result;
    }
    
}
